#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 PaleVioletRed
#property indicator_color2 DeepSkyBlue
#property indicator_width1 2
#property indicator_width2 3


//
//
//
//
//
//

extern string TimeFrame        = "Current time frame";
extern int    Length                    = 34;
extern int    Price                     = 0;
extern double Phase                     = 0;
extern int    atrperiod                 = 7;
extern int    overbought                = 80;
extern int    oversold                  = 20;
extern int    FastLen                   = 5;
extern int    SlowLen                   = 34;
extern int    Len                       = 1;
extern int    StochasticKPeriod         = 14;
extern int    StochasticSlowing         = 3;
extern int    StochasticSlowingMaMethod = 4;
extern int    StochasticDPeriod         = 3;
extern int    StochasticDMaMethod       = 4;
extern bool   Interpolate               = true;

//
//
//
//
//

double Ind_Buffer1[];
double Ind_Buffer2[];

string indicatorFileName;
bool   returnBars;
bool   calculateValue;
int    timeFrame;

//--------------------------------------------------------------------------
//
//--------------------------------------------------------------------------
//
//
//
//

int init()
{
   SetIndexBuffer(0,Ind_Buffer1);
   SetIndexBuffer(1,Ind_Buffer2);
      
      //
      //
      //
      //
      //
      
         indicatorFileName = WindowExpertName();
         returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
         calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
         timeFrame         = stringToTimeFrame(TimeFrame);
      
      //
      //
      //
      //
      //
      
   string short_name=timeFrameToString(timeFrame)+" Double Smooth Jurik BrainTrend1StopLine";
            SetIndexLabel(0,""+short_name+"_SELL"); 
            SetIndexLabel(1,""+short_name+"_BUY"); 
   IndicatorShortName(short_name);
   return(0);
}
int deinit() { return(0); }

//--------------------------------------------------------------------------
//
//--------------------------------------------------------------------------
//
//
//
//

double work[][2];
#define _r 0
#define _p 1

int start()
{
   int i,a,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { Ind_Buffer1[0]=limit; return(0); }

   //
   //
   //
   //
   //
            
   if (calculateValue || timeFrame == Period())
   {
      if (ArrayRange(work,0) != Bars) ArrayResize(work,Bars);
      
      //
      //
      //
      //
      //
      
      double calcLength = MathSqrt(Length);
      for(i=limit, a=Bars-i-1; i>=0; i--,a++)
      { 
         double Range       = iATR(NULL,0,atrperiod,i)/ 2.3;
         double range1      = iATR(NULL,0,10,i)* 1.5;
         double value2      = iCustom(NULL,0,"Stochastic zerolagMacd",FastLen,SlowLen,Len,StochasticKPeriod,StochasticSlowing,StochasticSlowingMaMethod,StochasticDPeriod,StochasticDMaMethod,0,i);
                work[a][_r] = work[a-1][_r];
                work[a][_p] = work[a-1][_p];
         double CloseVal    = NormalizeDouble(iDSmooth(iMA(NULL,0,1,0,MODE_SMA,Price,i),     calcLength,Phase,i,   0),Digits);
         double CloseVal2   = NormalizeDouble(iDSmooth(iMA(NULL,0,1,0,MODE_SMA,Price,i+2),   calcLength,Phase,i+2,20),Digits);
         double HighVal     = NormalizeDouble(iDSmooth(iMA(NULL,0,1,0,MODE_SMA,PRICE_HIGH,i),calcLength,Phase,i,  40),Digits);
         double LowVal      = NormalizeDouble(iDSmooth(iMA(NULL,0,1,0,MODE_SMA,PRICE_LOW,i), calcLength,Phase,i,  60),Digits);
         double val1        = 0;
         double val2        = 0;
         double val3        = MathAbs(CloseVal - CloseVal2);
  
         //
         //
         //
         //
         //
         
         if (value2 < oversold && val3 > Range && work[a][_p] != 1 )
         {
            val1           = HighVal + range1 / 4.0;
            work[a][_p]    = 1;
            work[a][_r]    = val1;
            Ind_Buffer1[i] = val1;
            Ind_Buffer2[i]=EMPTY_VALUE;
         }
         if (value2 > overbought && val3 > Range && work[a][_p] != 2 )
         {
            val2           = LowVal - range1 / 4.0;
            work[a][_p]    = 2;
            work[a][_r]    = val2;
            Ind_Buffer1[i] = EMPTY_VALUE;
            Ind_Buffer2[i] = val2;
         }
  
         double value4 = HighVal + range1;
         double value5 = LowVal  - range1;
         
         if (val1 == 0 && val2 == 0)
         {
            if (work[a][_p] == 1)
               if (value4 < work[a][_r])
               {
                  work[a][_r]    = value4;
                  Ind_Buffer1[i] = work[a][_r];
                  Ind_Buffer2[i] = EMPTY_VALUE;
               }
               else
               {
                  Ind_Buffer1[i] = work[a][_r];
                  Ind_Buffer2[i] = EMPTY_VALUE;
               }
            if (work[a][_p] == 2)
               if (value5 > work[a][_r] )
               {
                  work[a][_r]    = value5;
                  Ind_Buffer1[i] = EMPTY_VALUE;
                  Ind_Buffer2[i] = work[a][_r];
               }
               else
               {
                  Ind_Buffer1[i] = EMPTY_VALUE;
                  Ind_Buffer2[i] = work[a][_r];
               }
         }
      }  
      return(0);
   }      
   
   //
   //
   //
   //
   //

   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for (i=limit; i>=0; i--)
   {
      int y  = iBarShift(NULL,timeFrame,Time[i]);
         Ind_Buffer1[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Length,Price,Phase,atrperiod,overbought,oversold,FastLen,SlowLen,Len,StochasticKPeriod,StochasticSlowing,StochasticSlowingMaMethod,StochasticDPeriod,StochasticDMaMethod,0,y);
         Ind_Buffer2[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Length,Price,Phase,atrperiod,overbought,oversold,FastLen,SlowLen,Len,StochasticKPeriod,StochasticSlowing,StochasticSlowingMaMethod,StochasticDPeriod,StochasticDMaMethod,1,y);
            if (!Interpolate || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;

         //
         //
         //
         //
         //
                  
         interpolate(Ind_Buffer1,iTime(NULL,timeFrame,y),i);
         interpolate(Ind_Buffer2,iTime(NULL,timeFrame,y),i);
   }   
   return(0);
}



//--------------------------------------------------------------------------
//
//--------------------------------------------------------------------------
//
//
//
//
//

void interpolate(double& buffer[], datetime time, int i)
{
   for (int n = 1; (i+n) < Bars && Time[i+n] >= time; n++) continue;
   
   //
   //
   //
   //
   //
   
   if (buffer[i] == EMPTY_VALUE || buffer[i+n] == EMPTY_VALUE) n=-1;
               double increment = (buffer[i+n] - buffer[i])/ n;
   for (int k = 1; k < n; k++)     buffer[i+k] = buffer[i] + k*increment;
}


//--------------------------------------------------------------------------
//
//--------------------------------------------------------------------------
//
//
//
//
//

double wrk[][80];

#define bsmax  5
#define bsmin  6
#define volty  7
#define vsum   8
#define avolty 9

//
//
//
//
//

double iDSmooth(double price, double length, double phase, int i, int s=0)
{
   return (iSmooth(iSmooth(price,length,phase,i,s),length,phase,i,s+10));
}

//
//
//
//
//

double iSmooth(double price, double length, double phase, int i, int s=0)
{
   if (length <=1) return(price);
   if (ArrayRange(wrk,0) != Bars) ArrayResize(wrk,Bars);
   
   int r = Bars-i-1; 
      if (r==0) { for(int k=0; k<7; k++) wrk[r][k+s]=price; for(; k<10; k++) wrk[r][k+s]=0; return(price); }

   //
   //
   //
   //
   //
   
      double len1   = MathMax(MathLog(MathSqrt(0.5*(length-1)))/MathLog(2.0)+2.0,0);
      double pow1   = MathMax(len1-2.0,0.5);
      double del1   = price - wrk[r-1][bsmax+s];
      double del2   = price - wrk[r-1][bsmin+s];
      double div    = 1.0/(10.0+10.0*(MathMin(MathMax(length-10,0),100))/100);
      int    forBar = MathMin(r,10);
	
         wrk[r][volty+s] = 0;
               if(MathAbs(del1) > MathAbs(del2)) wrk[r][volty+s] = MathAbs(del1); 
               if(MathAbs(del1) < MathAbs(del2)) wrk[r][volty+s] = MathAbs(del2); 
         wrk[r][vsum+s] =	wrk[r-1][vsum+s] + (wrk[r][volty+s]-wrk[r-forBar][volty+s])*div;
         
         //
         //
         //
         //
         //
   
         wrk[r][avolty+s] = wrk[r-1][avolty+s]+(2.0/(MathMax(4.0*length,30)+1.0))*(wrk[r][vsum+s]-wrk[r-1][avolty+s]);
            if (wrk[r][avolty+s] > 0)
               double dVolty = wrk[r][volty+s]/wrk[r][avolty+s]; else dVolty = 0;   
	               if (dVolty > MathPow(len1,1.0/pow1)) dVolty = MathPow(len1,1.0/pow1);
                  if (dVolty < 1)                      dVolty = 1.0;

      //
      //
      //
      //
      //
	        
   	double pow2 = MathPow(dVolty, pow1);
      double len2 = MathSqrt(0.5*(length-1))*len1;
      double Kv   = MathPow(len2/(len2+1), MathSqrt(pow2));

         if (del1 > 0) wrk[r][bsmax+s] = price; else wrk[r][bsmax+s] = price - Kv*del1;
         if (del2 < 0) wrk[r][bsmin+s] = price; else wrk[r][bsmin+s] = price - Kv*del2;
	
   //
   //
   //
   //
   //
      
      double R     = MathMax(MathMin(phase,100),-100)/100.0 + 1.5;
      double beta  = 0.45*(length-1)/(0.45*(length-1)+2);
      double alpha = MathPow(beta,pow2);

         wrk[r][0+s] = price + alpha*(wrk[r-1][0+s]-price);
         wrk[r][1+s] = (price - wrk[r][0+s])*(1-beta) + beta*wrk[r-1][1+s];
         wrk[r][2+s] = (wrk[r][0+s] + R*wrk[r][1+s]);
         wrk[r][3+s] = (wrk[r][2+s] - wrk[r-1][4+s])*MathPow((1-alpha),2) + MathPow(alpha,2)*wrk[r-1][3+s];
         wrk[r][4+s] = (wrk[r-1][4+s] + wrk[r][3+s]); 

   //
   //
   //
   //
   //

   return(wrk[r][4+s]);
}
   
//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}